@echo off &setlocal DisableDelayedExpansion

set "inFile=test.txt"
set "outFile=test.pdf"
::      paper size of A4 in pt          tab width in number of spaces    font size in pt  nonzero for landscape orientation
set /a "pageHeight=842, pageWidth=595,  tabWidth=8,                      fontSize=10,     landscape=0"
:: Letter: pageHeight=792, pageWidth=612,
:: A3:     pageHeight=1190, pageWidth=842,


set "tab=	"
set "spcs=                                                                                                    "
for /f %%a in ('copy /z "%~f0" nul') do set "cr=%%a"
for /f "tokens=1,3" %%a in ('reg query "HKCU\Control Panel\International"^|findstr /i "\<[is]Date\>"') do set "%%a=%%b"
for /f "tokens=1-6 delims=:.,%sDate%" %%a in ("%date:* =%,%time: =0%") do (
  if %iDate%==0 (set mm=%%a&set dd=%%b&set yy=%%c) else if %iDate%==1 (set dd=%%a&set mm=%%b&set yy=%%c) else (set yy=%%a&set mm=%%b&set dd=%%c)
  (set h=%%d&set m=%%e&set s=%%f)
)
if 1%yy% LSS 200 if 1%yy% LSS 170 (set yy=20%yy%) else (set yy=19%yy%)

if %tabWidth% lss 2 set "tabWidth=2"
if %pageHeight% lss 72 set "pageHeight=72"
if %pageWidth% lss 72 set "pageWidth=72"
if %landscape% neq 0 set /a "_tmp=pageWidth, pageWidth=pageHeight, pageHeight=_tmp"
for /f %%i in ('type "%inFile%"^|find /c /v ""') do (
  set /a "lineHight=(fontSize*12)/10,linesInPage=(pageHeight-72)/lineHight, pageCnt=%%i/linesInPage, linesInLast=%%i %% linesInPage, hMinus40=pageHeight-40"
)
if %linesInPage% lss 1 set "linesInPage=1"
if %linesInLast% equ 0 (set /a "linesInLast=linesInPage") else set /a "pageCnt+=1"

setlocal EnableDelayedExpansion
>"!outFile!" echo(%%PDF-1.1

for %%i in ("!outFile!") do set "objPos[1]=%%~zi"
>>"!outFile!" (
  echo(1 0 obj
  echo(^<^<
  echo(/CreationDate ^(D:!yy!!mm!!dd!!h!!m!!s!^)
  echo(/Producer ^(text2pdf.bat^)
  echo(/Title ^(text2pdf^)
  echo(^>^>
  echo(endobj
)

for %%i in ("!outFile!") do set "objPos[2]=%%~zi"
>>"!outFile!" (
  echo(2 0 obj
  echo(^<^<
  echo(/Type /Catalog
  echo(/Pages 3 0 R
  echo(^>^>
  echo(endobj
)

for %%i in ("!outFile!") do set "objPos[4]=%%~zi"
>>"!outFile!" (
  echo(4 0 obj
  echo(^<^<
  echo(/Type /Font
  echo(/Subtype /Type1
  echo(/Name /F1
  echo(/BaseFont /Courier
  echo(/Encoding /WinAnsiEncoding
  echo(^>^>
  echo(endobj
)

for %%i in ("!outFile!") do set "objPos[5]=%%~zi"
>>"!outFile!" (
  echo(5 0 obj
  echo(^<^<
  echo(/Font ^<^< /F1 4 0 R ^>^>
  echo(/ProcSet [ /PDF /Text ]
  echo(^>^>
  echo(endobj
)

:: begin pages ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
set /a "objects=5, pages=0"

<!inFile! (
  for /l %%h in (1 1 !pageCnt!) do (

    set /a "objects+=1, nextObject=objects+1, pages+=1"
    set "pageobj[!pages!]=!objects!"
    for %%i in ("!outFile!") do set "objPos[!objects!]=%%~zi"
    >>"!outFile!" (
      echo(!objects! 0 obj
      echo(^<^<
      echo(/Type /Page
      echo(/Parent 3 0 R
      echo(/Resources 5 0 R
      echo(/Contents !nextObject! 0 R
      echo(^>^>
      echo(endobj
    )

    set /a "objects+=1, nextObject=objects+1"
    for %%i in ("!outFile!") do set "objPos[!objects!]=%%~zi"
    >>"!outFile!" (
      echo(!objects! 0 obj
      echo(^<^<
      echo(/Length !nextObject! 0 R
      echo(^>^>
      echo(stream
    )

    for %%i in ("!outFile!") do set "streampos=%%~zi"
    >>"!outFile!" (
      echo(BT
      echo(/F1 !fontSize! Tf
      echo(1 0 0 1 50 !hMinus40! Tm
      echo(!lineHight! TL
    )

    if %%h equ !pageCnt! (set "n=!linesInLast!") else set "n=!linesInPage!"
    >>"!outFile!" (
      for /l %%j in (1 1 !n!) do (
        set "ln=" &set /p "ln="
        if defined ln call :proc_line
        echo(^(!ln!^)'
      )
      echo(^(^)'
      echo(ET
    )

    for %%i in ("!outFile!") do set /a "streamlen=%%~zi-streampos"
    >>"!outFile!" (
      echo(endstream
      echo(endobj
    )

    set /a "objects+=1, nextObject=objects+1"
    for %%i in ("!outFile!") do set "objPos[!objects!]=%%~zi"
    >>"!outFile!" (
      echo(!objects! 0 obj
      echo(!streamlen!
      echo(endobj
    )

  )
)
:: end pages ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

for %%i in ("!outFile!") do set "objPos[3]=%%~zi"
>>"!outFile!" (
  echo(3 0 obj
  echo(^<^<
  echo(/Type /Pages
  echo(/Count !pages!
  echo(/MediaBox [ 0 0 !pageWidth! !pageHeight! ]
  <nul set /p "=/Kids [ "
  for /l %%i in (1 1 !pages!) do <nul set /p "=!pageobj[%%i]! 0 R "
  echo(]
  echo(^>^>
  echo(endobj
)

for %%i in ("!outFile!") do set "xrefpos=%%~zi"

>>"!outFile!" (
  echo(xref
  echo(0 !nextObject!
  <nul set /p "=0000000000 65535 f !cr!"
  for /l %%i in (1 1 !objects!) do (
    set "pos=0000000000!objPos[%%i]!"
    <nul set /p "=!pos:~-10! 00000 n !cr!"
  )
  echo(trailer
  echo(^<^<
  echo(/Size !nextObject!
  echo(/Root 2 0 R
  echo(/Info 1 0 R
  echo(^>^>
  echo(startxref
  echo(!xrefpos!
  echo(%%%%EOF
  echo(
)
endlocal
pause
exit /b

:proc_line
for /f "tokens=1* delims=%tab%" %%i in ("X!ln!") do if "%%j" neq "" (
  set "str=X!ln!"
  set "len=0"
  for /l %%i in (12 -1 0) do (
    set /a "len|=1<<%%i"
    for %%j in (!len!) do if "!str:~%%j,1!"=="" set /a "len&=~1<<%%i"
  )
  set /a "len-=1"
  call :tab_recur 0
)
for %%i in ("\=\\" "(=\(" ")=\)") do set "ln=!ln:%%~i!"
exit /b

:tab_recur
if %1 lss !len! (
  set /a "nxt=%1+1"
  if "!ln:~%1,1!"=="%tab%" (
    set /a "d=0-(%1 %% tabWidth)+tabWidth, e=nxt, nxt+=d-1, len+=d-1"
    for /f "tokens=1,2" %%d in ("!d! !e!") do set "ln=!ln:~0,%1!!spcs:~0,%%d!!ln:~%%e!"
  )
  call :tab_recur !nxt!
)
exit /b
